class I18nProxy
{
    constructor(i18nManager)
    {
        return new Proxy(i18nManager,
        {
            get(target, name, receiver)
            {
                if(!this.keys)
                    this.keys = Object.keys(target.localeBundles);

                if(typeof name === 'symbol')
                    return null;

                return (...args) =>
                {

                    if(name.endsWith('Object'))
                    {
                        name = name.substr(0, name.length - 6);

                        const result = { };
                        const origLocale = target.locale;

                        this.keys.forEach(key =>
                        {
                            target.locale = key;
                            result[key] = target[name].call(target, ...args);
                        });

                        target.locale = origLocale;

                        return result;
                    }
                    else if(target[name])
                    {
                        return target[name].call(target, ...args);
                    }
                    else
                    {
                        return target;
                    }
                }
            }
        });
    }
}

module.exports = I18nProxy
